import { Component } from '@wordpress/element';
import { __ } from '@wordpress/i18n';
import { PanelRow, ToggleControl } from '@wordpress/components';
import MediaQueryControlFlexRight from '../../../media-query/control/flex-right';
import getData from '../utils/get-data';
import getPropertyHasValueByMediaQueries from '../utils/get-property-has-value-by-media-queries';
import { getKeyOrDefault } from '../../../../../utils';

export default class extends Component {
	render() {
		const { setAttributes, mediaDevices, mediaActiveDevice, labels, pseudoClass } = this.props;

		const data = getData(
			this.props.data,
			mediaActiveDevice,
			pseudoClass
		);

		const mediaUsages = getPropertyHasValueByMediaQueries(
			this.props.data,
			'display',
			mediaDevices,
			display => display === 'none'
		);

		return (
			<PanelRow className="tces-row-with-media-query-controls">
				<ToggleControl
					label={ getKeyOrDefault( labels, 'display', __( 'Hide element', 'wpv-views' ) ) }
					checked={ data.display === 'none' }
					onChange={ display => {
						display = display ? 'none' : undefined; setAttributes( { display } );
					} }
				/>
				<MediaQueryControlFlexRight mediaUsages={ mediaUsages } />
			</PanelRow>

		);
	}
}
