// WordPress dependencies.
import { Component } from '@wordpress/element';

// Internal dependencies.
import { Rotate } from '../../../index';
import getData from '../utils/get-data';
import getPropertyHasValueByMediaQueries from '../utils/get-property-has-value-by-media-queries';
import MediaQueryControlFlexRight from '../../../media-query/control/flex-right';

export default class extends Component {
	render() {
		const { setAttributes, mediaDevices, mediaActiveDevice, pseudoClass } = this.props;

		const data = getData(
			this.props.data,
			mediaActiveDevice,
			pseudoClass
		);

		const mediaUsages = getPropertyHasValueByMediaQueries(
			this.props.data,
			'rotate',
			mediaDevices
		);

		return (
			<Rotate
				label={ '' }
				value={ data.rotate }
				onChange={ val => setAttributes( { rotate: ! isNaN( val ) ? parseInt( val, 10 ) : undefined } ) }
				mediaQueryControl={ <MediaQueryControlFlexRight mediaUsages={ mediaUsages } /> }
			/>
		);
	}
}
