import { Component } from '@wordpress/element';

import StyleRenderer from './style_renderer';

const styleRenderer = new StyleRenderer();

class GridGap extends Component {
	render() {
		const { gridProps } = this.props;

		if ( this.props.rowGapDisplay ) {
			return (
				<style
					type="text/css"
					dangerouslySetInnerHTML={
						{ __html: styleRenderer.buildRowGapStyles( this.props.parent, gridProps ) }
					}
				/>
			);
		}

		if ( this.props.columnGapDisplay ) {
			const colGaps = [],
				{ columns } = gridProps,
				totalGap = gridProps.columnGap * ( columns.length - 1 );
			let left = 0;
			for ( let i = 0; i < columns.length - 1; i++ ) {
				left += columns[ i ];
				const style = {
					left: `calc( ( 100% - ${ totalGap }px ) * ${ left } + ${ i * gridProps.columnGap }px )`,
					// marginLeft: `${ -gridProps.columnGap / 2 }px`,
					width: `${ gridProps.columnGap }px`,
				};
				colGaps.push(
					<div className="tb-col-gap" style={ style }></div>
				);
			}
			return colGaps;
		}

		return null;
	}
}

export default GridGap;
