// WordPress Dependencies
import { compose } from '@wordpress/compose';
import { withDispatch, withSelect } from '@wordpress/data';

// Internal Dependencies
import { name as storeMediaQuery } from '../store';
import Abstract from './abstract';

class FlexRight extends Abstract {
	render() {
		return (
			<div className="tces-media-query-control tces-media-query-control-flex-right-reversed">
				{ this.getDevicesIcons() }
			</div>
		);
	}
}

const FlexRightComposed = compose( [
	withSelect( ( select ) => {
		const { getMediaDevices, getMediaActiveDevice, getMediaControlDisplayOnlyDesktop } = select( storeMediaQuery );
		return {
			mediaDevices: getMediaDevices(),
			mediaActiveDevice: getMediaActiveDevice(),
			mediaControlDisplayOnlyDesktop: getMediaControlDisplayOnlyDesktop(),
		};
	} ),
	withDispatch( ( dispatch ) => {
		const { changeMediaDevice } = dispatch( storeMediaQuery );
		return {
			changeMediaDevice( targetDevice ) {
				changeMediaDevice( targetDevice );
			},
		};
	} ),
] )( FlexRight );

export default FlexRightComposed;
