// WordPress Dependencies
import { registerStore } from '@wordpress/data';

// Internal Dependencies
import reducer from './reducer';
import * as actions from './actions';
import * as selectors from './selectors';
import { MEDIA_QUERIES, MEDIA_QUERY_KEY_DESKTOP } from '../index';

export const name = 'toolset/mediaQuery';

const store = registerStore( name, {
	reducer,
	actions,
	selectors,
	initialState: {
		mediaDevices: MEDIA_QUERIES,
		mediaActiveDevice: MEDIA_QUERY_KEY_DESKTOP,
		displayOnlyDesktop: false,
	},
} );

export default store;
