import { MEDIA_QUERY_KEY_DESKTOP } from '../index';
import wpColumnsAdjustByState from '../utils/wp-columns-adjust-by-state';
/**
 * Reducer for store rwd.
 *
 * @param {Object} state  Current state.
 * @param {Object} action Dispatched action.
 *
 * @return {Object} Updated state.
 */
function settings( state = {}, action ) {
	switch ( action.type ) {
		case 'CHANGE_MEDIA_DEVICE':
			if ( ! state.mediaDevices[ action.payload ] ) {
				// Selected device does not exist.
				return state;
			}

			if ( action.payload === state.mediaActiveDevice ) {
				/* We decided to always display all icons. If this should change uncomment following block.

				if( state.mediaActiveDevice === MEDIA_QUERY_KEY_DESKTOP ) {
					// Desktop is clicked while active. Toggle displayOnlyDesktop.
					return {
						...state,
						displayOnlyDesktop: ! state.displayOnlyDesktop,
					};
				}

			 	*/

				// The current active device is selected.
				return state;
			}

			// New State.
			const newState = {
				...state,
				mediaActiveDevice: action.payload,
				displayOnlyDesktop: action.payload === MEDIA_QUERY_KEY_DESKTOP,
			};

			// Adjust wp columns per row.
			wpColumnsAdjustByState( newState );

			// Different available device selected.
			return newState;
		default:
			// Unknown action.
			return state;
	}
}

export default settings;
