import { render } from '@wordpress/element';

import HeaderToolbar from '../control/header-toolbar';

const controlsContainerId = 'tces-header-toolbar-media-query';

const placeIconsOnHeaderToolbar = () => {
	const wpHeaderToolbar = document.getElementsByClassName( 'edit-post-header' );

	if ( wpHeaderToolbar.length === 0 ) {
		// Core change. Adjustments are required.
		return;
	}

	const controlsContainer = document.createElement( 'div' );
	controlsContainer.setAttribute( 'id', controlsContainerId );

	wpHeaderToolbar[ 0 ].insertBefore( controlsContainer, wpHeaderToolbar[ 0 ].lastChild );

	render(
		<HeaderToolbar />,
		controlsContainer
	);
};

export default function() {
	if ( document.readyState === 'complete' || document.readyState === 'interactive' ) {
		placeIconsOnHeaderToolbar();
	} else {
		window.addEventListener( 'DOMContentLoaded', placeIconsOnHeaderToolbar );
	}
}

